/*
 * libmowgli: A collection of useful routines for programming.
 * metadata.h: Object metadata.
 *
 * Copyright (c) 2007 William Pitcock <nenolod -at- sacredspiral.co.uk>
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice is present in all copies.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef MOWGLI_SRC_LIBMOWGLI_OBJECT_METADATA_H_INCLUDE_GUARD
#define MOWGLI_SRC_LIBMOWGLI_OBJECT_METADATA_H_INCLUDE_GUARD 1

#include "object/object.h"

typedef struct
{
	char *name;
	void *data;
} mowgli_object_metadata_entry_t;

extern void mowgli_object_metadata_associate(mowgli_object_t *self, const char *key, void *value);
extern void mowgli_object_metadata_dissociate(mowgli_object_t *self, const char *key);
extern void *mowgli_object_metadata_retrieve(mowgli_object_t *self, const char *key);

#endif /* MOWGLI_SRC_LIBMOWGLI_OBJECT_METADATA_H_INCLUDE_GUARD */
